﻿local _G = _G
local Skills = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Skills", {
	type = "data source",
	icon = "Interface\\Icons\\Trade_Engineering",
	label = "Skills",
})

local cache = {
	names = {},
	rank = {},
	max = {},
	mod = {},
}

function Skills:OnTooltipShow()
	self:AddLine("Skills")
	for _, name in ipairs(cache.names) do
		if cache.rank[name] then
			self:AddDoubleLine(name, ("%d%s/%d"):format(cache.rank[name], cache.mod[name] > 0 and ("(+%d)"):format(cache.mod[name]) or '', cache.max[name]))
		else
			self:AddLine(name, 1, 1, 1)
		end
	end
end

local function skill_update()
	table.wipe(cache.names)
	for skillIndex=1, GetNumSkillLines() do
		local skillName, isHeader, _, skillRank, _, skillModifier, skillMaxRank = GetSkillLineInfo(skillIndex)
		table.insert(cache.names, skillName)
		if not isHeader then
			cache.rank[skillName] = skillRank
			cache.max[skillName] = skillMaxRank
			cache.mod[skillName] = skillModifier
		end
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:RegisterEvent("SKILL_LINES_CHANGED")
frame:SetScript("OnEvent", function()
	skill_update()
end)

